// ChildView.h : interface of the CChildView class
//


#pragma once

#include "gdiplus.h"
using namespace Gdiplus;
using Gdiplus::Bitmap;


// CChildView window

class CChildView : public CScrollView //CWnd
{
// Construction
public:
	CChildView();


// Attributes
public:

// Operations
public:

// Overrides
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

// Implementation
public:
	virtual ~CChildView();

	void SetBitmapFilename(int side, CString filename);
	void SetCurrentView(int side);
	void SetZoom(int scale);

	// Unfortunately, the GDI+ Bitmap object does not copy the image buffer
	// when constructed. So we need to maintain this buffer in parallel.
	typedef struct
	{
		CString filename;
		Bitmap*	pBitmap;
		char*	pImageBuffer;
	} ImageInfo;

	ImageInfo	m_frontImage;
	ImageInfo	m_backImage;
	int			m_currentViewSide;
	bool		m_fitToWindow;
	float		m_scale;
	CPoint		m_prevMousePos;
	bool		m_leftButtonIsDown;

	void LoadBitmapFile(ImageInfo & imageInfo);

	// Generated message map functions
protected:
	afx_msg void OnDraw(CDC *pDC) ;
	
	DECLARE_MESSAGE_MAP()

private:

	ULONG_PTR m_gdiplusToken;
	void UpdateScale();

public:
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	virtual void OnInitialUpdate();
	afx_msg void OnWindowPosChanged(WINDOWPOS* lpwndpos);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
};

