// MainFrm.h : interface of the CMainFrame class
//


#pragma once

#include "ChildView.h"
#include "ScanDialog.h"
#include "ViewDialog.h"
#include <string>
using namespace std;



class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame();
	void SetStatusText(string text);

protected: 
	DECLARE_DYNAMIC(CMainFrame)

// Attributes
public:

// Operations
public:

// Overrides
public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	BOOL OnIdle(LONG lCount);
	void SetBitmapFilename(int side, CString filename);

	void ShowScanDialog(bool show);

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	CChildView	*m_pWndView;

	ScanDialog	m_scanDialog;
	ViewDialog	m_viewDialog;

	bool m_prefeedEnabled;


// Generated message map functions
protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnFilePrefeed();
	afx_msg void OnUpdateFilePrefeed(CCmdUI *pCmdUI);
};


