#pragma once


////////////////////////////////////////////////////////////////////////////
//
// DialogBarEx window
//
//	There are a couple of limitations in the CDialogBar class that make it
//	behave unlike a dialog box. It does not have an OnInitDialog function 
//	that derived classes can override to perform initialization. Also, it does 
//	not support the DDX mechanism.
//
//	The DialogBarEx class adds these two capabilities so that derived classes 
//	can behave more like a dialog box.
//
//	This class was taken directly from an article found at http://www.codeguru.com.
//	Navigate to: 
//		Home -> VisualC++/C++ -> Windows&Dialogs -> Dialod->DDX/DDV -> Enhancing CDialogBar with InitDialog and DDX.
//
//	Also used was information found at: http://samuelrobinson.com/DlgBar.htm.
//
////////////////////////////////////////////////////////////////////////////

class DialogBarEx : public CDialogBar
{
	DECLARE_DYNAMIC(DialogBarEx)

	// Construction / Destruction
	public:
	DialogBarEx();
	virtual ~DialogBarEx();

	// Attributes
	public:

	// Operations
	public:

	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(DialogBarEx)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

	// Implementation
	public:
	BOOL Create(CWnd * pParentWnd, UINT nIDTemplate, UINT nStyle, UINT
	nID);
	BOOL Create(CWnd * pParentWnd, LPCTSTR lpszTemplateName, UINT
	nStyle, UINT nID);

	protected:
	virtual BOOL OnInitDialogBar();

	// Generated message map functions
	protected:
	//{{AFX_MSG(DialogBarEx)
	// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	virtual void OnUpdateCmdUI(CFrameWnd* pTarget, BOOL bDisableIfNoHandler);
};




