// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "SpeedbirdTest.h"
#include "Scanner.h"

#include "MainFrm.h"
#include ".\mainfrm.h"
#include "gdiplus.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
//	ON_WM_DESTROY()
ON_BN_CLICKED(IDC_FRONT_VIEW_CHECK, OnBnClickedFrontViewCheck)
ON_BN_CLICKED(IDC_BACK_VIEW_CHECK, OnBnClickedBackViewCheck)
ON_BN_CLICKED(IDC_OPEN_CLOSE_CHECK, OnBnClickedOpenCloseCheck)
ON_BN_CLICKED(IDC_CALIBRATION_CHECK, OnBnClickedCalibrationCheck)
ON_BN_CLICKED(IDC_STATUS_CHECK, OnBnClickedStatusCheck)
ON_BN_CLICKED(IDC_SCAN_PARAMETERS_CHECK, OnBnClickedScanParametersCheck)
ON_BN_CLICKED(IDC_SCAN_ACTIONS_CHECK, OnBnClickedScanActionsCheck)
ON_BN_CLICKED(IDC_OTHER_CHECK, OnBnClickedOtherCheck)
ON_BN_CLICKED(IDC_ZOOM_CHECK, OnBnClickedZoomCheck)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	m_currentlyActiveButtonID = 0;
	m_pCurrentlyActiveDialog = NULL;
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// Do not delete this view. MFC will delete it.
	// In the CView destructor it will delete itself.
	m_wndView = new CChildView();

	// create a view to occupy the client area of the frame
	if (!m_wndView->Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}
	m_wndView->SetZoom(true);

#if 0
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
#endif

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

#if 0
	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
#endif

	if (!m_dialogBar.Create(this, IDD_DIALOGBAR,
		CBRS_TOP|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_DIALOGBAR))
	{
		TRACE0("Failed to create DlgBar\n");
		return -1;      // fail to create
	}

	if (!m_openCloseDialog.Create(this, IDD_OPEN_CLOSE,
		CBRS_LEFT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_OPEN_CLOSE))
	{
		TRACE0("Failed to create OpenCloseDialog\n");
		return -1;      // fail to create
	}
	m_openCloseDialog.ShowWindow(SW_HIDE);

	if (!m_calibrationDialog.Create(this, IDD_CALIBRATION,
		CBRS_LEFT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_CALIBRATION))
	{
		TRACE0("Failed to create CalibrationDialog\n");
		return -1;      // fail to create
	}
	m_calibrationDialog.ShowWindow(SW_HIDE);

	if (!m_statusDialog.Create(this, IDD_STATUS,
		CBRS_LEFT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_STATUS))
	{
		TRACE0("Failed to create StatusDialog\n");
		return -1;      // fail to create
	}
	m_statusDialog.ShowWindow(SW_HIDE);

	if (!m_scanParametersDialog.Create(this, IDD_SCAN_PARAMETERS,
		CBRS_LEFT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_SCAN_PARAMETERS))
	{
		TRACE0("Failed to create ScanParametersDialog\n");
		return -1;      // fail to create
	}
	m_scanParametersDialog.ShowWindow(SW_HIDE);

	if (!m_scanActionsDialog.Create(this, IDD_SCAN_ACTIONS,
		CBRS_LEFT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_SCAN_ACTIONS))
	{
		TRACE0("Failed to create ScanActionsDialog\n");
		return -1;      // fail to create
	}
	m_scanActionsDialog.ShowWindow(SW_HIDE);

	if (!m_otherDialog.Create(this, IDD_OTHER,
		CBRS_LEFT|CBRS_TOOLTIPS|CBRS_FLYBY, IDD_OTHER))
	{
		TRACE0("Failed to create OtherDialog\n");
		return -1;      // fail to create
	}
	m_otherDialog.ShowWindow(SW_HIDE);


	CButton *pFrontCheckbox = (CButton*)m_dialogBar.GetDlgItem(IDC_FRONT_VIEW_CHECK);
	CButton *pBackCheckbox = (CButton*)m_dialogBar.GetDlgItem(IDC_BACK_VIEW_CHECK);
	
	pFrontCheckbox->SetCheck(TRUE);
	pBackCheckbox->SetCheck(FALSE);


	// Simulate a button click to the OpenClose button so that this
	// dialog is shown first on startup.
	::SendMessage(m_dialogBar.GetDlgItem(IDC_OPEN_CLOSE_CHECK)->GetSafeHwnd(),
		BM_CLICK, 0, 0);
	m_currentlyActiveButtonID = IDC_OPEN_CLOSE_CHECK;

	// Adjust the window size so all of the controls can be seen without 
	// having to manually resize the window size.
	SetWindowPos(&CWnd::wndBottom, 0, 0, 700, 590, SWP_NOMOVE|SWP_NOZORDER|SWP_NOACTIVATE);

	return 0;
}

// Pass idle time processing along to the scanActions dialog which
// reads image data during idle time.
BOOL CMainFrame::OnIdle(LONG lCount)
{
	return m_scanActionsDialog.OnIdle(lCount);
}


void CMainFrame::PostNcDestroy()
{
	// TODO: Add your specialized code here and/or call the base class

	// Close the interface in case it's open. It won't 
	// hurt to call SI_CloseInterface() if it's not open.
	if(g_scanner.IsAttached())
	{
		g_scanner.SI_CloseInterface();

		g_scanner.Detach();
	}

	CFrameWnd::PostNcDestroy();
}


BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

void CMainFrame::InterfaceOpened()
{
	m_scanParametersDialog.PropertiesToControls();
}


// CMainFrame message handlers

void CMainFrame::OnSetFocus(CWnd* /*pOldWnd*/)
{
	// forward focus to the view window
	m_wndView->SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView->OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


void CMainFrame::SetBitmapFilename(int side, CString filename)
{
	m_wndView->SetBitmapFilename(side, filename);
}


void CMainFrame::OnBnClickedFrontViewCheck()
{

	CButton *pFrontCheckbox = (CButton*)m_dialogBar.GetDlgItem(IDC_FRONT_VIEW_CHECK);
	CButton *pBackCheckbox = (CButton*)m_dialogBar.GetDlgItem(IDC_BACK_VIEW_CHECK);
	
	BOOL frontState = pFrontCheckbox->GetCheck();
	pBackCheckbox->SetCheck(frontState ? FALSE : TRUE);

	m_wndView->SetCurrentView(frontState ? 0 : 1);
}

void CMainFrame::OnBnClickedBackViewCheck()
{
	CButton *pFrontCheckbox = (CButton*)m_dialogBar.GetDlgItem(IDC_FRONT_VIEW_CHECK);
	CButton *pBackCheckbox = (CButton*)m_dialogBar.GetDlgItem(IDC_BACK_VIEW_CHECK);
	
	BOOL backState = pBackCheckbox->GetCheck();
	
	pFrontCheckbox->SetCheck(backState ? FALSE : TRUE);

	m_wndView->SetCurrentView(backState ? 1 : 0);
}

void CMainFrame::OnBnClickedZoomCheck()
{
	CButton *pZoomCheckbox = (CButton*)m_dialogBar.GetDlgItem(IDC_ZOOM_CHECK);

	BOOL zoomState = pZoomCheckbox->GetCheck();

	pZoomCheckbox->SetWindowText(zoomState ? "1:1" : "Fit");

	m_wndView->SetZoom(zoomState ? false : true);

}

// A utility function to eliminate redundant code in OnBnClickedOpenCloseCheck(),
// OnBnClickedCalibrationCheck(), etc.
void CMainFrame::UpdateDialogBars(int buttonID, DialogBarEx* pDialog)
{

	pDialog->ShowWindow(pDialog->IsWindowVisible() ? SW_HIDE : SW_SHOW   );
	

	// Check to see if there is currently a dialog showing by checking if 
	// m_currentlyActiveButtonID has been set. If so, hide that window and
	// release the button.
	if(m_currentlyActiveButtonID != buttonID)
	{
		// Simulate a button click to the currently depressed button. This will
		// release it and hide the assocated dialog.
		::SendMessage(m_dialogBar.GetDlgItem(m_currentlyActiveButtonID)->GetSafeHwnd(),
			BM_CLICK, 0, 0);
	}
	m_currentlyActiveButtonID = pDialog->IsWindowVisible() ? buttonID : 0;


	// Send a WM_SIZE message to force the window to redraw the dialog bars.
	// But don't actually change the size.
	CRect rect;
	GetWindowRect(rect);
	SendMessage(WM_SIZE, rect.Width(), rect.Height());
}

void CMainFrame::OnBnClickedOpenCloseCheck()
{
	UpdateDialogBars(IDC_OPEN_CLOSE_CHECK, &m_openCloseDialog);
}

void CMainFrame::OnBnClickedCalibrationCheck()
{
	UpdateDialogBars(IDC_CALIBRATION_CHECK, &m_calibrationDialog);
}

void CMainFrame::OnBnClickedStatusCheck()
{
	UpdateDialogBars(IDC_STATUS_CHECK, &m_statusDialog);
}

void CMainFrame::OnBnClickedScanParametersCheck()
{
	UpdateDialogBars(IDC_SCAN_PARAMETERS_CHECK, &m_scanParametersDialog);
}

void CMainFrame::OnBnClickedScanActionsCheck()
{
	UpdateDialogBars(IDC_SCAN_ACTIONS_CHECK, &m_scanActionsDialog);
}

void CMainFrame::OnBnClickedOtherCheck()
{
	UpdateDialogBars(IDC_OTHER_CHECK, &m_otherDialog);
}


// Enable or disable all buttons on the dialog bar except the Open/Close button.
void CMainFrame::EnableNonOpenCloseButtons(BOOL enable)
{

	m_dialogBar.GetDlgItem(IDC_CALIBRATION_CHECK)->EnableWindow(enable);
	m_dialogBar.GetDlgItem(IDC_STATUS_CHECK)->EnableWindow(enable);
	m_dialogBar.GetDlgItem(IDC_SCAN_PARAMETERS_CHECK)->EnableWindow(enable);
	m_dialogBar.GetDlgItem(IDC_SCAN_ACTIONS_CHECK)->EnableWindow(enable);
	m_dialogBar.GetDlgItem(IDC_OTHER_CHECK)->EnableWindow(enable);
}
