// OtherDialog.cpp : implementation file
//

#include "stdafx.h"
#include "SpeedbirdTest.h"
#include "OtherDialog.h"
#include "Scanner.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// OtherDialog dialog

IMPLEMENT_DYNAMIC(OtherDialog, DialogBarEx)
OtherDialog::OtherDialog(CWnd* pParent /*=NULL*/)
{
}

OtherDialog::~OtherDialog()
{
}

void OtherDialog::DoDataExchange(CDataExchange* pDX)
{
	DialogBarEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LAST_ERROR_STATIC, m_lastErrorStatic);
	DDX_Control(pDX, IDC_LAST_ERROR_TEXT_STATIC, m_lastErrorTextStatic);
	DDX_Control(pDX, IDC_GET_EVENT_STATIC, m_getEventStatic);
	DDX_Control(pDX, IDC_EVENT_COMBO, m_eventDataCombo);
	DDX_Control(pDX, IDC_DIAGNOSTIC_COMBO, m_diagnosticCombo);
	DDX_Control(pDX, IDC_DIAGNOSTIC_STATIC, m_diagnosticStatic);
	DDX_Control(pDX, IDC_READ_LENGTH_EDIT, m_readLengthEdit);

	
}


BEGIN_MESSAGE_MAP(OtherDialog, DialogBarEx)
	ON_BN_CLICKED(IDC_GET_LAST_ERROR_BUTTON, OnBnClickedGetLastErrorButton)
	ON_BN_CLICKED(IDC_GET_LAST_ERROR_TEXT_BUTTON, OnBnClickedGetLastErrorTextButton)
	ON_BN_CLICKED(IDC_RESET_BUTTON, OnBnClickedResetButton)
	ON_BN_CLICKED(IDC_GET_EVENT_BUTTON, OnBnClickedGetEventButton)
	ON_BN_CLICKED(IDC_DIAGNOSTIC_BUTTON, OnBnClickedDiagnosticButton)
	ON_CBN_SELCHANGE(IDC_DIAGNOSTIC_COMBO, OnDiagnosticComboSelectChanged)
END_MESSAGE_MAP()


// OtherDialog message handlers

void OtherDialog::OnBnClickedGetLastErrorButton()
{
	// TODO: Add your control notification handler code here
	CString errorValue = GetResultCodeIdentifierAsText(g_scanner.SI_GetLastError());

	m_lastErrorStatic.SetWindowText(errorValue);

}

void OtherDialog::OnBnClickedGetLastErrorTextButton()
{
	// TODO: Add your control notification handler code here
	char *pErrorText;

	g_scanner.SI_GetLastErrorText(&pErrorText);

	m_lastErrorTextStatic.SetWindowText(pErrorText);
}


void OtherDialog::OnBnClickedResetButton()
{
	// TODO: Add your control notification handler code here

	if(MessageBox("Reset the scanner?\nAre you sure?", "Reset", MB_OKCANCEL))
	{

		SIResult result;

		result = g_scanner.SI_Reset();

		if(result != SIR_SUCCESS)
		{
			char *pErrorText;
			g_scanner.SI_GetLastErrorText(&pErrorText);
			MessageBox(pErrorText);
		}

	}
}



void OtherDialog::OnBnClickedGetEventButton()
{
	CString textbuf;
	SIResult result;


	m_eventDataCombo.GetWindowText(textbuf);

	// Only get one byte translated. The event data returned by Speedbird 
	// through the USB interface is always only one byte in size.
	// Bit 1 set should translate to SIEVT_PAPER_IN.
	// Bit 2 set should translate to SIEVT_BUTTON_DOWN.
	// 
	SIEventInfo eventInfo;
	eventInfo.eventData[0] = atoi(textbuf);
	eventInfo.eventDataSize = 1;


	result = g_scanner.SI_GetEvent(&eventInfo);
	
	if(result != SIR_SUCCESS)
	{
		char *pErrorText;
		g_scanner.SI_GetLastErrorText(&pErrorText);
		MessageBox(pErrorText);
		return;
	}

	textbuf = "";

	switch(eventInfo.eventFlags)
	{
		case SIEVT_PAPER_IN:
			textbuf = "Paper In";
			break;
		case SIEVT_BUTTON_DOWN:
			textbuf = "Button Down";
			break;
		case SIEVT_PAPER_IN | SIEVT_BUTTON_DOWN:
			textbuf = "Paper In and Button Down";
			break;
		default:
			textbuf = "none";
	};

	m_getEventStatic.SetWindowText(textbuf);

}


char *OtherDialog::GetResultCodeIdentifierAsText(SIResult result)
{
	switch(result)
	{
		case SIR_SUCCESS:						return "SIR_SUCCESS";
		case SIR_UNKNOWN_MODEL_NAME:			return "SIR_UNKNOWN_MODEL_NAME";
		case SIR_SCANNER_NOT_READY:				return "SIR_SCANNER_NOT_READY";
		case SIR_BAD_PARAMETER:					return "SIR_BAD_PARAMETER";
		case SIR_ALREADY_OPEN:					return "SIR_ALREADY_OPEN";
		case SIR_INTERFACE_NOT_OPEN:			return "SIR_INTERFACE_NOT_OPEN";
		case SIR_FILESYSTEM_ACCESS_DENIED:		return "SIR_FILESYSTEM_ACCESS_DENIED";
		case SIR_SCANNER_BUSY:					return "SIR_SCANNER_BUSY";
		case SIR_ENDOFDATA:						return "SIR_ENDOFDATA";
		case SIR_DEVICE_COMMUNICATION_ERROR:	return "SIR_DEVICE_COMMUNICATION_ERROR";
		case SIR_UNKNOWN_ERROR:					return "SIR_UNKNOWN_ERROR";
		case SIR_NOT_CALIBRATED:				return "SIR_NOT_CALIBRATED";
		case SIR_INITIALIZATION_FAILURE:		return "SIR_INITIALIZATION_FAILURE";
		case SIR_USER_CANCELLED:				return "SIR_USER_CANCELLED";
		case SIR_CALIB_WHITE_TARGET:			return "SIR_CALIB_WHITE_TARGET";
		case SIR_PROPERTY_UNSUPPORTED:			return "SIR_PROPERTY_UNSUPPORTED";
		case SIR_PROPERTY_INVALID_VALUE:		return "SIR_PROPERTY_INVALID_VALUE";
		case SIR_PROPERTY_READONLY:				return "SIR_PROPERTY_READONLY";
	};
	return "Unknown result code";

}


BOOL OtherDialog::OnInitDialogBar()
{
	DialogBarEx::OnInitDialogBar();

	// TODO:  Add extra initialization here
	m_diagnosticCombo.InsertString(0, "Hardware presence");
	m_diagnosticCombo.SetItemData(0, SI_DIAG_HW_PRESENCE);

	m_diagnosticCombo.InsertString(1, "Read performance");
	m_diagnosticCombo.SetItemData(1, SI_DIAG_READ_PERFORMANCE);

	m_diagnosticCombo.SetCurSel(0);

	m_eventDataCombo.AddString("1");
	m_eventDataCombo.AddString("2");
	m_eventDataCombo.SetCurSel(0);

	m_diagnosticStatic.SetWindowText("Unknown");
	m_readLengthEdit.SetWindowText("20");
	OnDiagnosticComboSelectChanged();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void OtherDialog::OnBnClickedDiagnosticButton()
{
	// TODO: Add your control notification handler code here

	SIResult result;

	m_diagnosticStatic.SetWindowText("---");

	// Retrieve the diagnostic test code from the list
	SIDiagTest test = (SIDiagTest)m_diagnosticCombo.GetItemData(m_diagnosticCombo.GetCurSel());
	
	SIDiagHwPresenceInfo	diagHwPresInfo;
	SIDiagReadPerfInfo		diagReadPerfInfo;

	switch(test)
	{
		case SI_DIAG_HW_PRESENCE:
		{
			result = g_scanner.SI_Diagnostic(test, &diagHwPresInfo);
			break;
		}
		case SI_DIAG_READ_PERFORMANCE:
		{
			CString readLengthText;

			// Set up the SIDiagReadPerfInfo structure with the amount of data to read.
			m_readLengthEdit.GetWindowText(readLengthText);
			diagReadPerfInfo.readLengthInKB = atoi((LPCTSTR)readLengthText);
			if(diagReadPerfInfo.readLengthInKB > 100)
			{
				MessageBox("Read length must be between 0 and 100 KB.");
				return;
			}
			result = g_scanner.SI_Diagnostic(test, &diagReadPerfInfo);
			break;
		}
		default:
			MessageBox("Invalid diagnostic test in combo box.");
			return;
	};

	if(result != SIR_SUCCESS)
	{
		char *pErrorText;
		g_scanner.SI_GetLastErrorText(&pErrorText);
		MessageBox(pErrorText);
		m_diagnosticStatic.SetWindowText("Unknown");
		return;
	}

	// Let the "---" text be visible for a bit to give a visual indication that
	// the operation occurred.
	Sleep(100);

	CString str;

	if(test == SI_DIAG_HW_PRESENCE)
	{
		switch(diagHwPresInfo.result)
		{
			case SI_DIAG_PASS:
				m_diagnosticStatic.SetWindowText("Passed");
				break;
			case SI_DIAG_FAIL:
				m_diagnosticStatic.SetWindowText("Failed");
				break;
			default:
				m_diagnosticStatic.SetWindowText("Invalid test result returned.");
				break;
		};
	}
	else if(test == SI_DIAG_READ_PERFORMANCE)
	{
		// the result returned is the time to read a constant amount of data 
		// from the scanner's memory.
		str.Format("%d uS", diagReadPerfInfo.timeInMicroSec);
		m_diagnosticStatic.SetWindowText(str);

	};

}

// This function is called when the user changes the selection in the 
// diagnostic combo box. All it does is keep the readLength edit box grayed
// out unless the readPerformance diagnostic is selected. The read length 
// is only ussed in the readPerformance test.
void OtherDialog::OnDiagnosticComboSelectChanged()
{

	// Retrieve the diagnostic test code from the list
	SIDiagTest test = (SIDiagTest)m_diagnosticCombo.GetItemData(m_diagnosticCombo.GetCurSel());

	m_readLengthEdit.EnableWindow(test == SI_DIAG_READ_PERFORMANCE);

}

