#pragma once

#include "DialogBarEx.h"
#include "BitmapFile.h"

// ScanActionsDialog dialog

class ScanActionsDialog : public DialogBarEx
{
	DECLARE_DYNAMIC(ScanActionsDialog)

public:
	ScanActionsDialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~ScanActionsDialog();

// Dialog Data
	enum { IDD = IDD_SCAN_ACTIONS };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedStartScanButton();
	afx_msg void OnBnClickedEndScanButton();

	static UINT ReadImageDataThreadProc(LPVOID pParam);
	BOOL OnIdle(LONG lCount);

private:
	static int	AlignInPlace(unsigned char* pBuffer, int numberOfLines, int bytesPerLine);

private:

	enum { BUFFER_SIZE_IN_BYTES = 0x8000 };
	unsigned char*	m_lineBuffer;
	int				m_linesPerBuffer;
	int				m_lineWidthInBytes;
	BitmapFile		m_bitmapFile[2];
	int				m_scanLength;
	int				m_bitsPerPixel;
	int				m_scanWidthInPixels;
	CString			m_filename[2];

	enum	{	SS_IDLE, 
				SS_INIT, 
				SS_READ, 
				SS_CANCEL,
				SS_END
			} m_scanState;
	int m_currentReadSide;
	int m_numSidesToRead;
	int m_totalLinesLeftToRead;
	int m_totalLinesRead;
	bool m_endScan;



public:
	virtual BOOL OnInitDialogBar();
protected:
	virtual void PostNcDestroy();
public:
	afx_msg void OnBnClickedFeedButton();
	afx_msg void OnBnClickedFeedPaperOutButton();
};
