// StatusDialog.cpp : implementation file
//

#include "stdafx.h"
#include "SpeedbirdTest.h"
#include "StatusDialog.h"
#include "Scanner.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// StatusDialog dialog

IMPLEMENT_DYNCREATE(StatusDialog, DialogBarEx)

StatusDialog::StatusDialog(CWnd* pParent /*=NULL*/)
{
}

StatusDialog::~StatusDialog()
{
}

void StatusDialog::DoDataExchange(CDataExchange* pDX)
{
	DialogBarEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SCANNER_STATUS_STATIC, m_scannerStatusStatic);
	DDX_Control(pDX, IDC_PAPER_STATUS_STATIC, m_paperStatusStatic);
	DDX_Control(pDX, IDC_BUTTON_STATUS_STATIC, m_buttonStatusStatic);
}


BEGIN_MESSAGE_MAP(StatusDialog, DialogBarEx)
	ON_BN_CLICKED(IDC_SCANNER_STATUS_BUTTON, OnBnClickedScannerStatusButton)
	ON_BN_CLICKED(IDC_PAPER_STATUS_BUTTON, OnBnClickedPaperStatusButton)
	ON_BN_CLICKED(IDC_BUTTON_STATUS_BUTTON, OnBnClickedButtonStatusButton)
END_MESSAGE_MAP()


BOOL StatusDialog::OnInitDialogBar()
{
	DialogBarEx::OnInitDialogBar();

	// TODO:  Add extra initialization here
	m_scannerStatusStatic.SetWindowText("Unknown");
	m_paperStatusStatic.SetWindowText("Unknown");
	m_buttonStatusStatic.SetWindowText("Unknown");

	return TRUE;  // return TRUE  unless you set the focus to a control
}


// StatusDialog message handlers


void StatusDialog::OnBnClickedScannerStatusButton()
{
	// TODO: Add your control notification handler code here

	SIResult result;
	SIScannerStatus status;

	// Give a visual cue so you know the status has been updated.
	m_scannerStatusStatic.SetWindowText("------");
	Sleep(100);

	result = g_scanner.SI_GetScannerStatus(&status);

	if(result == SIR_SUCCESS)
	{
		if(status == SI_SS_OFFLINE)
		{
			m_scannerStatusStatic.SetWindowText("The scanner is not available.");
		}
		else if (status == SI_SS_ONLINE_READY)
		{
			m_scannerStatusStatic.SetWindowText("The scanner is online and ready.");
		}
		else if (status == SI_SS_ONLINE_BUSY)
		{
			m_scannerStatusStatic.SetWindowText("The scanner is online but currently busy.");
		}
		else
		{
			MessageBox("Invalid scanner status value returned.");
		}

	}
	else
	{
		char *pErrorText;
		g_scanner.SI_GetLastErrorText(&pErrorText);
		MessageBox(pErrorText);
		m_scannerStatusStatic.SetWindowText("Unknown");
	}



}

void StatusDialog::OnBnClickedPaperStatusButton()
{
	// TODO: Add your control notification handler code here

	SIResult result;
	SIPaperStatus status;

	// Give a visual cue so you know the status has been updated.
	m_paperStatusStatic.SetWindowText("------");
	Sleep(100);

	result = g_scanner.SI_GetPaperStatus(&status);

	if(result == SIR_SUCCESS)
	{
		if(status == SI_PS_PAPER_IN)
		{
			m_paperStatusStatic.SetWindowText("Paper IN");
		}
		else if (status == SI_PS_PAPER_OUT)
		{
			m_paperStatusStatic.SetWindowText("Paper OUT");
		}
		else
		{
			MessageBox("Invalid paper status value returned.");
		}
	}
	else
	{
		char *pErrorText;
		g_scanner.SI_GetLastErrorText(&pErrorText);
		MessageBox(pErrorText);
		m_paperStatusStatic.SetWindowText("Unknown");
	}
}

void StatusDialog::OnBnClickedButtonStatusButton()
{
	// TODO: Add your control notification handler code here
	SIResult result;
	SIButtonStatus status;

	// Give a visual cue so you know the status has been updated.
	m_buttonStatusStatic.SetWindowText("------");
	Sleep(100);

	result = g_scanner.SI_GetButtonStatus(0, &status);

	if(result == SIR_SUCCESS)
	{
		if(status == SI_BS_UP)
		{
			m_buttonStatusStatic.SetWindowText("Button is UP");
		}
		else if (status == SI_BS_DOWN)
		{
			m_buttonStatusStatic.SetWindowText("Button is DOWN");
		}
		else
		{
			MessageBox("Invalid button status value returned.");
		}
	}
	else
	{
		char *pErrorText;
		g_scanner.SI_GetLastErrorText(&pErrorText);
		MessageBox(pErrorText);
		m_buttonStatusStatic.SetWindowText("Unknown");
	}
}
